"
 COPYRIGHT (c) 1993 by Claus Gittinger
	      All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"

ImageReader subclass:#JPEGReader
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Graphics-Images-Support'
!

!JPEGReader primitiveDefinitions!
%{

/*
 * includes, defines, structure definitions
 * and typedefs come here.
 */

#include <jpeglib.h>
#include <jerror.h>

%}
! !

!JPEGReader class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 1993 by Claus Gittinger
	      All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
!

documentation
"
    Reader for JPEG images.

    This is a quick&dirty hack, using the PD djpeg tool to convert 
    the JPG image to PNM first, then reads the PNM image using PBMReader.

    Of course, this is slower than it should be. If lots of JPG reading
    is done, this class should be rewritten, to directly call the (C) JPG
    decoding functions.

    Only reading of files is supported.

    CAVEAT:
        you have to have the djpeg program installed.

    [See also:]
        Image Form Icon
        BlitImageReader FaceReader GIFReader PBMReader PCXReader 
        ST80FormReader SunRasterReader TargaReader TIFFReader WindowsIconReader 
        XBMReader XPMReader XWDReader 
"
! !

!JPEGReader class methodsFor:'initialization'!

initialize
    "install myself in the Image classes fileFormat table
     for the `.jpg' and '.jpeg' extensions."

    Image addReader:self suffix:'jpg'.
    Image addReader:self suffix:'jpeg'.

    "Modified: 1.2.1997 / 15:01:55 / cg"
! !

!JPEGReader class methodsFor:'reading from file'!

fromFile:aFileName
    "read a jpg image from a file.
     Make it the easy way: let djpeg convert it to gif,
     then let GIFReader read the file."

    |tempFileName reader|

    tempFileName := '/tmp/img' , (OperatingSystem getProcessId printString).

    'JPEGREADER [info]: converting to ppm ..' infoPrintCR.
    (OperatingSystem executeCommand:'djpeg -pnm ' , aFileName , ' > ' , tempFileName)
    ifFalse:[
        (OperatingSystem executeCommand:'../../support/libjpeg/djpeg -pnm ' , aFileName , ' > ' , tempFileName)    
        ifFalse:[
            'JPEGREADER [warning]: conversion failed ..' errorPrintCR.
            'JPEGREADER [warning]: .. cannot execute converter: djpeg' errorPrintCR.
            ^ nil
        ].
    ].

    reader := PBMReader fromFile:tempFileName.
    OperatingSystem executeCommand:'rm ' , tempFileName.
    ^ reader

    "
     JPEGReader fromFile:'bitmaps/testimg.jpg'
    "

    "Modified: 11.4.1997 / 16:39:59 / cg"
! !

!JPEGReader class methodsFor:'testing'!

isValidImageFile:aFileName
    "return true, if aFileName contains a JPG image.
     Only look at the files name here ..."

    (aFileName asLowercase endsWith:'.jpg') ifTrue:[^ true].
    (aFileName asLowercase endsWith:'.jpeg') ifTrue:[^ true].
    ^ false

    "Created: 11.4.1997 / 16:26:25 / cg"
! !

!JPEGReader class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/libview2/JPEGReader.st,v 1.19 1997-04-11 14:44:54 cg Exp $'
! !
JPEGReader initialize!
